## grfcodec 6.0.6

=== debian/changelog ===
grfcodec (6.0.6-6build2) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- William Grant <wgrant@ubuntu.com>  Mon, 01 Apr 2024 16:54:47 +1100

grfcodec (6.0.6-6build1) noble; urgency=medium

  * No-change rebuild against libpng16-16t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Thu, 29 Feb 2024 06:48:32 +0000

grfcodec (6.0.6-6) unstable; urgency=medium

  [ Matthijs Kooijman ]
  * [0353f34] Update watch file
  * [5499e4d] Fix FTBFS with gcc-11 (Closes: #984158)
  * [ef145c9] Bump standards version to 4.6.0 (no changes required)
  * [f02a6aa] Update lintian override

  [ Jenkins ]
  * [b26c412] Set upstream metadata fields: Bug-Database, Bug-Submit,
    Repository, Repository-Browse.

 -- Matthijs Kooijman <matthijs@stdin.nl>  Tue, 23 Nov 2021 12:14:35 +0100

grfcodec (6.0.6-5) unstable; urgency=medium

  * [99dfb79] Fix FTBFS with gcc-10 (Closes: 957307)
  * [8fcd1da] Bump standards version to 4.5.0 (no changes required)
  * [86688bd] Bump debhelper version to v13

 -- Matthijs Kooijman <matthijs@stdin.nl>  Wed, 12 Aug 2020 14:39:33 +0200

grfcodec (6.0.6-4) unstable; urgency=medium

  [ Jordi Mallach ]
  * [454e069] Move M-A field to binary section
  * [90e6e31] Set Rules-Requires-Root: no

  [ Matthijs Kooijman ]
  * [2a5a991] Support DEB_BUILD_OPTIONS=terse
  * [44c66ad] Update Standards-Version to 4.3.0
  * [14c98ae] Bump debhelper version to v12 (no changes required)

 -- Matthijs Kooijman <matthijs@stdin.nl>  Tue, 15 Oct 2019 13:03:31 +0200

grfcodec (6.0.6-3) unstable; urgency=medium

  [ Jordi Mallach ]
  * [e61a00b] Force build to abort upon endian_check failure. Thanks to
    Helmut Grohne for suggesting this fix (Closes: #922625)

 -- Matthijs Kooijman <matthijs@stdin.nl>  Tue, 12 Mar 2019 22:19:01 +0100

grfcodec (6.0.6-2) unstable; urgency=medium

  * [4dce67c] Bump debhelper version to v11
  * [eca5421] Bump standards version to 4.1.4
  * [8d4f2a1] Convert Priority: extra to optional
  * [cda4980] Mark as Multi-arch: foreign

 -- Matthijs Kooijman <matthijs@stdin.nl>  Thu, 10 May 2018 21:42:34 +0200

grfcodec (6.0.6-1) unstable; urgency=medium

  * [dd04bd9] New upstream release 6.0.6.
     - Fixes compilation with GCC 6 (Closes: #811833)
  * [b5921f7] Bump debhelper version to v9.

 -- Matthijs Kooijman <matthijs@stdin.nl>  Sun, 03 Jul 2016 10:49:04 +0200

=== debian/control ===
Source: grfcodec
Section: devel
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Matthijs Kooijman <matthijs@stdin.nl>
Uploaders: Jordi Mallach <jordi@debian.org>
Build-Depends: debhelper-compat (= 13), libboost-dev, libpng-dev, dpkg-dev (>=1.16.1)
Standards-Version: 4.6.0
Vcs-Browser: https://salsa.debian.org/openttd-team/grfcodec
Vcs-Git: https://salsa.debian.org/openttd-team/grfcodec.git
Homepage: https://github.com/OpenTTD/grfcodec
Rules-Requires-Root: no

Package: grfcodec
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Replaces: nforenum
Conflicts: nforenum
Multi-Arch: foreign
Description: suite of programs to modify Transport Tycoon Deluxe's GRF files
 This package provides the grfcodec, grfdiff, grfmerge and nforenum commands
 which can be used to work with the GRF used by the Transport Tycoon Deluxe,
 TTDPatch and OpenTTD games.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Use debhelper default for all targets (but some are overridden below).
%:
	dh $@

# Enable all hardening options (since grfcodec potentially handles
# untrusted data files).
DEB_BUILD_MAINT_OPTIONS=hardening=+all

# Load buildflags (this uses dpkg-buildflags). Note that we don't export
# them, but instead pass them to ./configure explicitly.
include /usr/share/dpkg/buildflags.mk

# Don't use dh for clean. Since the upstream Makefile generates
# dependency information before any error messages, dh_auto_clean
# sometimes thinks make distclean is supported, while it isn't. Instead,
# we use make mrproper, which does something similar.
override_dh_auto_clean:
	make mrproper
	# Remove files autogenerated by make, but not removed by make
	# mrproper.
	rm -f Makefile.local

override_dh_auto_configure:
	# Disable UPX binary compression, it is not available on all
	# platforms.
	echo "UPX=" >> Makefile.local
	echo "DO_NOT_INSTALL_CHANGELOG=1" >> Makefile.local
	echo "DO_NOT_INSTALL_LICENSE=1" >> Makefile.local
ifeq (,$(filter terse,$(DEB_BUILD_OPTIONS)))
	echo "V=1" >> Makefile.local
endif
	echo "CXXFLAGS=$(CXXFLAGS) $(CPPFLAGS) -std=c++11" >> Makefile.local
	echo "LDOPT=$(LDFLAGS)" >> Makefile.local
	echo "prefix=/usr" >> Makefile.local

=== debian/watch ===
version=4

https://www.openttd.org/downloads/grfcodec-releases/latest .*/grfcodec-(\d.*)-source\.(?:tgz|tbz2|txz|tar\.(?:gz|bz2|xz))

## grfcodec 6.1.0

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5)

project(grfcodec)

set(CMAKE_CXX_STANDARD 11)
set(CMAKE_CXX_STANDARD_REQUIRED)
set(CMAKE_CXX_EXTENSIONS NO)

if(MINGW)
	# Force searching static libs, so the executables can run outside MinGW environment
	set(CMAKE_FIND_LIBRARY_SUFFIXES ".a")

	# Force static linking, so the executables can run outside MinGW environment
	link_libraries(-static -static-libgcc -static-libstdc++)
endif()

if(MSVC)
	# Switch to MT (static) instead of MD (dynamic) binary

	# For MSVC two generators are available
	# - a command line generator (Ninja) using CMAKE_BUILD_TYPE to specify the
	#   configuration of the build tree
	# - an IDE generator (Visual Studio) using CMAKE_CONFIGURATION_TYPES to
	#   specify all configurations that will be available in the generated solution
	list(APPEND MSVC_CONFIGS "${CMAKE_BUILD_TYPE}" "${CMAKE_CONFIGURATION_TYPES}")

	# Set usage of static runtime for all configurations
	foreach(MSVC_CONFIG ${MSVC_CONFIGS})
		string(TOUPPER "CMAKE_CXX_FLAGS_${MSVC_CONFIG}" MSVC_FLAGS)
		string(REPLACE "/MD" "/MT" ${MSVC_FLAGS} "${${MSVC_FLAGS}}")
	endforeach()

	add_compile_options(
		/wd4996 # Disable deprecation warnings
		/W3
	)
elseif(CMAKE_CXX_COMPILER_ID STREQUAL "GNU" OR CMAKE_CXX_COMPILER_ID STREQUAL "Clang" OR CMAKE_CXX_COMPILER_ID STREQUAL "AppleClang")
	add_compile_options(
		-Wall
		-Wextra
		-Wno-format-nonliteral
	)
endif()


# Add some -D flags for Debug builds. We cannot use add_definitions(), because
# it does not appear to support the $<> tags.
add_compile_options(
    "$<$<CONFIG:Debug>:-D_DEBUG>"
    "$<$<NOT:$<CONFIG:Debug>>:-D_FORTIFY_SOURCE=2>" # FORTIFY_SOURCE should only be used in non-debug builds (requires -O1+)
)
if(MINGW)
    add_link_options(
        "$<$<NOT:$<CONFIG:Debug>>:-fstack-protector>" # Prevent undefined references when _FORTIFY_SOURCE > 0
    )
endif()


find_package(PNG)
find_package(Boost REQUIRED)


include(TestBigEndian)
TEST_BIG_ENDIAN(IS_BIG_ENDIAN)
if(IS_BIG_ENDIAN)
	add_definitions(-DGRFCODEC_BIG_ENDIAN=1)
else()
	add_definitions(-DGRFCODEC_LITTLE_ENDIAN=1)
endif()


include(CheckCXXSymbolExists)
check_cxx_symbol_exists("fmemopen" "cstdio" HAS_FMEMOPEN)
if(HAS_FMEMOPEN)
	add_definitions(-DWITH_FMEMOPEN)
endif()


# Prepare generated dir
set(GENERATED_BINARY_DIR "${CMAKE_BINARY_DIR}/generated")
include_directories("${GENERATED_BINARY_DIR}")

# Target to generate version.h
add_custom_target(version_header
	COMMAND ${CMAKE_COMMAND}
		-DGENERATED_BINARY_DIR=${GENERATED_BINARY_DIR}
		-DCPACK_BINARY_DIR=${CMAKE_BINARY_DIR}
		-P "${CMAKE_CURRENT_SOURCE_DIR}/generate_version.cmake"
	WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}
	BYPRODUCTS "${GENERATED_BINARY_DIR}/version.h"
)

# Target to generate ttpal.h
set(PALETTE_SOURCE_FILES
	${CMAKE_CURRENT_SOURCE_DIR}/src/pals/ttd_norm.bcp
	${CMAKE_CURRENT_SOURCE_DIR}/src/pals/ttw_norm.bcp
	${CMAKE_CURRENT_SOURCE_DIR}/src/pals/ttd_cand.bcp
	${CMAKE_CURRENT_SOURCE_DIR}/src/pals/ttw_cand.bcp
	${CMAKE_CURRENT_SOURCE_DIR}/src/pals/tt1_norm.bcp
	${CMAKE_CURRENT_SOURCE_DIR}/src/pals/tt1_mars.bcp
	${CMAKE_CURRENT_SOURCE_DIR}/src/pals/ttw_pb_pal1.bcp
	${CMAKE_CURRENT_SOURCE_DIR}/src/pals/ttw_pb_pal2.bcp
)
add_custom_target(palettes_header
	COMMAND ${CMAKE_COMMAND}
		-D INPUT_FILE=${CMAKE_CURRENT_SOURCE_DIR}/src/ttdpal.h.in
		-D OUTPUT_FILE=${GENERATED_BINARY_DIR}/ttdpal.h
		-P "${CMAKE_CURRENT_SOURCE_DIR}/src/pal2c.cmake"
		--
		${PALETTE_SOURCE_FILES}
	DEPENDS ${PALETTE_SOURCE_FILES}
	DEPENDS "${CMAKE_CURRENT_SOURCE_DIR}/src/ttdpal.h.in"
	DEPENDS "${CMAKE_CURRENT_SOURCE_DIR}/src/pal2c.cmake"
	BYPRODUCTS "${GENERATED_BINARY_DIR}/ttdpal.h"
	WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}
)


# Create grfid
add_executable(grfid)
add_dependencies(grfid version_header)


# Create grfstrip
add_executable(grfstrip)
add_dependencies(grfstrip version_header)


# Create nforenum
add_executable(nforenum)
add_dependencies(nforenum palettes_header version_header)
target_link_libraries(nforenum Boost::boost)


# Create grfcodec
add_executable(grfcodec)
add_dependencies(grfcodec palettes_header version_header)
target_link_libraries(grfcodec Boost::boost)
if(PNG_FOUND)
	set_target_properties(grfcodec PROPERTIES COMPILE_FLAGS -DWITH_PNG)
	target_link_libraries(grfcodec PNG::PNG)
endif()


# Add source files
add_subdirectory(src)


# Install files
include(GNUInstallDirs)

install(TARGETS
	grfid
	grfstrip
	nforenum
	grfcodec
	DESTINATION ${CMAKE_INSTALL_BINDIR}
)

install(FILES
	${CMAKE_CURRENT_SOURCE_DIR}/changelog.txt
	${CMAKE_CURRENT_SOURCE_DIR}/COPYING
	DESTINATION ${CMAKE_INSTALL_DOCDIR}
)

add_subdirectory(docs)


# CPack
if(WIN32)
	if(CMAKE_SIZEOF_VOID_P EQUAL 8)
		set(ARCHITECTURE "win64")
	else()
		set(ARCHITECTURE "win32")
	endif()

	set(CPACK_SYSTEM_NAME "${ARCHITECTURE}")
	set(CPACK_STRIP_FILES YES)
	set(CPACK_OUTPUT_FILE_PREFIX "bundles")
	set(CPACK_PACKAGE_FILE_NAME "grfcodec-#CPACK_PACKAGE_VERSION#-windows-${CPACK_SYSTEM_NAME}")

	set(CPACK_GENERATOR "ZIP")

	include(CPack)
endif()

=== docs/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5)

install(FILES
	${CMAKE_CURRENT_SOURCE_DIR}/grfcodec.1
	${CMAKE_CURRENT_SOURCE_DIR}/grfid.1
	${CMAKE_CURRENT_SOURCE_DIR}/grfstrip.1
	${CMAKE_CURRENT_SOURCE_DIR}/nforenum.1
	DESTINATION ${CMAKE_INSTALL_MANDIR}
)

install(FILES
	${CMAKE_CURRENT_SOURCE_DIR}/auto_correct.txt
	${CMAKE_CURRENT_SOURCE_DIR}/commands.txt
	${CMAKE_CURRENT_SOURCE_DIR}/grf.txt
	${CMAKE_CURRENT_SOURCE_DIR}/grfcodec.txt
	${CMAKE_CURRENT_SOURCE_DIR}/grftut.txt
	${CMAKE_CURRENT_SOURCE_DIR}/nforenum.txt
	${CMAKE_CURRENT_SOURCE_DIR}/readme.rpn.txt
	${CMAKE_CURRENT_SOURCE_DIR}/readme.md
	${CMAKE_CURRENT_SOURCE_DIR}/sanity.txt
	${CMAKE_CURRENT_SOURCE_DIR}/todo.txt
	DESTINATION ${CMAKE_INSTALL_DOCDIR}
)

=== src/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5)

add_subdirectory(msvc)


# Add files for grfid
target_sources(grfid PRIVATE
	${CMAKE_CURRENT_SOURCE_DIR}/grfid.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/md5.cpp
)


# Add files for grfstrip
target_sources(grfstrip PRIVATE
	${CMAKE_CURRENT_SOURCE_DIR}/grfstrip.cpp
)


# Add files for grfcodec
target_sources(grfcodec PRIVATE
	${CMAKE_CURRENT_SOURCE_DIR}/file.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/globals.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/grfcodec.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/grfcomm.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/info.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/mapescapes.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/path.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/pcxfile.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/pcxsprit.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/pngsprit.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/readinfo.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/sprites.cpp
)


# Add files for nforenum
target_sources(nforenum PRIVATE
	${CMAKE_CURRENT_SOURCE_DIR}/act0.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/act123_classes.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/act123.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/act14.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/act5.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/act6.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/act79D.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/actB.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/actF.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/command.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/data.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/globals.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/help.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/IDs.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/inject.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/language_mgr.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/mapescapes.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/message_mgr.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/messages.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/nforenum.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/pseudo.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/pseudo_seq.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/rangedint.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/sanity.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/strings.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/utf8.cpp
)

=== src/msvc/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5)

if(MSVC)
	# Add our own getopt to grfcodec
	target_sources(grfcodec PRIVATE ${CMAKE_CURRENT_SOURCE_DIR}/getopt.cpp)
	target_include_directories(grfcodec PRIVATE ${CMAKE_CURRENT_SOURCE_DIR})

	# Add our own getopt to nforenum
	target_sources(nforenum PRIVATE ${CMAKE_CURRENT_SOURCE_DIR}/getopt.cpp)
	target_include_directories(nforenum PRIVATE ${CMAKE_CURRENT_SOURCE_DIR})
endif()

=== debian/changelog ===
grfcodec (6.1.0-1) unstable; urgency=medium

  * [f3d156d] Update watch file
  * [6487532] New upstream release 6.1.0
  * [adb0596] Update debian/rules for upstream switch to cmake
  * [b1b2ba2] Remove all patches
  * [92e3907] Add patch to fix manpage install directory
  * [96c50a6] Bump standards version to 4.7.0 (no changes required)

 -- Matthijs Kooijman <matthijs@stdin.nl>  Mon, 24 Jun 2024 16:23:04 +0200

=== debian/control ===
--- 
+++ 
@@ -1,11 +1,10 @@
 Source: grfcodec
 Section: devel
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Matthijs Kooijman <matthijs@stdin.nl>
+Maintainer: Matthijs Kooijman <matthijs@stdin.nl>
 Uploaders: Jordi Mallach <jordi@debian.org>
-Build-Depends: debhelper-compat (= 13), libboost-dev, libpng-dev, dpkg-dev (>=1.16.1)
-Standards-Version: 4.6.0
+Build-Depends: debhelper-compat (= 13), libboost-dev, libpng-dev, dpkg-dev (>=1.16.1), cmake
+Standards-Version: 4.7.0
 Vcs-Browser: https://salsa.debian.org/openttd-team/grfcodec
 Vcs-Git: https://salsa.debian.org/openttd-team/grfcodec.git
 Homepage: https://github.com/OpenTTD/grfcodec

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Use debhelper default for all targets (but some are overridden below).
%:
	dh $@ --buildsystem=cmake

# Enable all hardening options (since grfcodec potentially handles
# untrusted data files).
export DEB_BUILD_MAINT_OPTIONS=hardening=+all

# Build release
CMAKE_CONFIG_ARGUMENTS += -DCMAKE_BUILD_TYPE=RelWithDebInfo

# Explicitly mark dependencies as required or disabled, so an issue with
# build dependencies does not silently remove a feature or add a
# dependency
CMAKE_CONFIG_ARGUMENTS += -DCMAKE_REQUIRE_FIND_PACKAGE_Boost=TRUE
CMAKE_CONFIG_ARGUMENTS += -DCMAKE_REQUIRE_FIND_PACKAGE_PNG=TRUE

override_dh_auto_configure:
	dh_auto_configure -- $(CMAKE_CONFIG_ARGUMENTS)

execute_after_dh_install-arch:
	# Prevent installing duplicate license file
	rm debian/grfcodec/usr/share/doc/grfcodec/COPYING

=== debian/watch ===
version=4
# API returns JSON, so use plain to disable HTML parsing (just grep the
# JSON for urls, which is not perfect but works well enough).
opts="searchmode=plain" \
https://api.github.com/repos/OpenTTD/@PACKAGE@/releases \
https://github.com/OpenTTD/@PACKAGE@/releases/download/[^/]*/@PACKAGE@-([\.\d]+)-source@ARCHIVE_EXT@
